Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::ReedTable Class Reference

STK reed table class. More...

`#include <ReedTable.h>`

Inheritance diagram for stk::ReedTable:

## Public Member Functions
| ReedTable (void)
| Default constructor.
void | setOffset (StkFloat offset)
| Set the table offset value. More...
void | setSlope (StkFloat slope)
| Set the table slope value. More...
StkFloat | tick (StkFloat input)
| Take one sample input and map to one sample of output.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Take a channel of the StkFrames object as inputs to the table and replace with corresponding outputs. More...
StkFrames & | tick (StkFrames &iFrames, StkFrames &oFrames, unsigned int iChannel=0, unsigned int oChannel=0)
| Take a channel of the `iFrames` object as inputs to the table and write outputs to the `oFrames` object. More...
Public Member Functions inherited from stk::Function
| Function (void)
| Class constructor.
StkFloat | lastOut (void) const
| Return the last computed output sample.
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes. More...

## Additional Inherited Members
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate. More...
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK reed table class.

This class implements a simple one breakpoint, non-linear reed function, as described by Smith (1986). This function is based on a memoryless non-linear spring model of the reed (the reed mass is ignored) which saturates when the reed collides with the mouthpiece facing.

See McIntyre, Schumacher, & Woodhouse (1983), Smith (1986), Hirschman, Cook, Scavone, and others for more information.

by Perry R. Cook and Gary P. Scavone, 1995–2017.

## Member Function Documentation

void stk::ReedTable::setOffset | ( | StkFloat | offset | ) |
| inline

Set the table offset value.

The table offset roughly corresponds to the size of the initial reed tip opening (a greater offset represents a smaller opening).

39 { offset_ = offset; };

void stk::ReedTable::setSlope | ( | StkFloat | slope | ) |
| inline

Set the table slope value.

The table slope roughly corresponds to the reed stiffness (a greater slope represents a harder reed).

47 { slope_ = slope; };

StkFrames & stk::ReedTable::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0`
| ) |  |
| inline

Take a channel of the StkFrames object as inputs to the table and replace with corresponding outputs.

The StkFrames argument reference is returned. The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

99 {
100 #if defined(_STK_DEBUG_)
101 if ( channel >= frames.channels() ) {
102 oStream_ << "ReedTable::tick(): channel and StkFrames arguments are incompatible!";
103 handleError( StkError::FUNCTION_ARGUMENT );
104 }
105 #endif
106
107 StkFloat *samples = &frames[channel];
108 unsigned int hop = frames.channels();
109 for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
110 *samples = offset_ + (slope_ * *samples);
111 if ( *samples > 1.0) *samples = 1.0;
112 if ( *samples < -1.0) *samples = -1.0;
113 }
114
115 lastFrame_[0] = *(samples-hop);
116 return frames;
117 }

StkFrames & stk::ReedTable::tick | ( | StkFrames & | iFrames,
|  | StkFrames & | oFrames,
|  | unsigned int | iChannel = `0`,
|  | unsigned int | oChannel = `0`
| ) |  |
| inline

Take a channel of the `iFrames` object as inputs to the table and write outputs to the `oFrames` object.

The `iFrames` object reference is returned. Each channel argument must be less than the number of channels in the corresponding StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

120 {
121 #if defined(_STK_DEBUG_)
122 if ( iChannel >= iFrames.channels() || oChannel >= oFrames.channels() ) {
123 oStream_ << "ReedTable::tick(): channel and StkFrames arguments are incompatible!";
124 handleError( StkError::FUNCTION_ARGUMENT );
125 }
126 #endif
127
128 StkFloat *iSamples = &iFrames[iChannel];
129 StkFloat *oSamples = &oFrames[oChannel];
130 unsigned int iHop = iFrames.channels(), oHop = oFrames.channels();
131 for ( unsigned int i=0; i<iFrames.frames(); i++, iSamples += iHop, oSamples += oHop ) {
132 *oSamples = offset_ + (slope_ * *iSamples);
133 if ( *oSamples > 1.0) *oSamples = 1.0;
134 if ( *oSamples < -1.0) *oSamples = -1.0;
135 }
136
137 lastFrame_[0] = *(oSamples-oHop);
138 return iFrames;
139 }

The documentation for this class was generated from the following file:

- ReedTable.h

The Synthesis ToolKit in C++ (STK)
©1995--2017 Perry R. Cook and Gary P. Scavone. All Rights Reserved.